Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/domvvl.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/domvvl.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/domvvl.F90	(revision 10001)
@@ -1047,4 +581,119 @@
    END SUBROUTINE dom_vvl_ctl
 
+   
+   SUBROUTINE ssh2e3_now
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE ssh2e3_now  ***
+      !!----------------------------------------------------------------------
+      INTEGER ::   ji, jj, jk
+      REAL(wp), DIMENSION(jpi,jpj) ::   zssht_h, zsshu_h, zsshv_h, zsshf_h
+      !!----------------------------------------------------------------------
+      !
+      !                             !==  ssh at u- and v-points  ==!
+      !
+      DO jj = 1, jpjm1                    ! start from 1 due to f-point
+         DO ji = 1, jpim1
+            zsshu_h(ji,jj) = 0.50_wp * ( sshn(ji  ,jj) + sshn(ji+1,jj  ) ) * ssumask(ji,jj)
+            zsshv_h(ji,jj) = 0.50_wp * ( sshn(ji  ,jj) + sshn(ji  ,jj+1) ) * ssvmask(ji,jj)
+            zsshf_h(ji,jj) = 0.25_wp * ( sshn(ji  ,jj) + sshn(ji  ,jj+1)   & 
+               &                       + sshn(ji+1,jj) + sshn(ji+1,jj+1) ) * ssfmask(ji,jj)
+         END DO
+      END DO      
+      CALL lbc_lnk_multi( zsshu_h(:,:),'U', 1._wp , zsshv_h(:,:),'V', 1._wp , zsshf_h(:,:),'F', 1._wp )
+      !
+      !                             !==  ht, hu and hv  == !   (and their inverse)
+      !
+      ht_n   (:,:) = ht_0(:,:) +  sshn  (:,:)
+      hu_n   (:,:) = hu_0(:,:) + zsshu_h(:,:)
+      hv_n   (:,:) = hv_0(:,:) + zsshv_h(:,:)
+      r1_hu_n(:,:) = ssumask(:,:) / ( hu_n(:,:) + 1._wp - ssumask(:,:) )    ! ss mask mask due to ISF
+      r1_hv_n(:,:) = ssvmask(:,:) / ( hv_n(:,:) + 1._wp - ssvmask(:,:) )
+      !      
+      !                             !==  ssh / h  factor at t-, u- ,v- & f-points  ==!
+      !
+      zssht_h(:,:) =  sshn  (:,:) * r1_ht_0(:,:)
+      zsshu_h(:,:) = zsshu_h(:,:) * r1_hu_0(:,:)
+      zsshv_h(:,:) = zsshv_h(:,:) * r1_hv_0(:,:)
+      zsshf_h(:,:) = zsshf_h(:,:) * r1_hf_0(:,:)
+      !
+      !                             !==  e3t, e3w  ,  e3u, e3uw ,  e3v, e3vw  , and e3f  ==!
+      !      
+      DO jk = 1, jpkm1
+          e3t_n(:,:,jk) =  e3t_0(:,:,jk) * ( 1._wp + zssht_h(:,:) * tmask(:,:,jk) )
+          e3w_n(:,:,jk) =  e3w_0(:,:,jk) * ( 1._wp + zssht_h(:,:) * tmask(:,:,jk) )
+          !
+          e3u_n(:,:,jk) =  e3u_0(:,:,jk) * ( 1._wp + zsshu_h(:,:) *  umask(:,:,jk) )
+         e3uw_n(:,:,jk) = e3uw_0(:,:,jk) * ( 1._wp + zsshu_h(:,:) * wumask(:,:,jk) )
+         !
+          e3v_n(:,:,jk) =  e3v_0(:,:,jk) * ( 1._wp + zsshv_h(:,:) *  vmask(:,:,jk) )
+         e3vw_n(:,:,jk) = e3vw_0(:,:,jk) * ( 1._wp + zsshv_h(:,:) * wvmask(:,:,jk) )
+          !
+          e3f_n(:,:,jk) =  e3f_0(:,:,jk) * ( 1._wp + zsshf_h(:,:) * fmask(:,:,jk) )
+      END DO
+      !      
+      !                             !== depth of t- and w-points  ==!
+      !
+      zssht_h(:,:) = 1._wp + zssht_h(:,:)     ! = 1 + sshn / ht_0
+      !
+      IF( ln_isfcav ) THEN    ! ISF cavities : ssh scaling not applied over the iceshelf thickness 
+         DO jk = 1, jpkm1
+            gdept_n(:,:,jk) = ( gdept_0(:,:,jk) - risfdep(:,:) ) * zssht_h(:,:) + risfdep(:,:)
+            gdepw_n(:,:,jk) = ( gdepw_0(:,:,jk) - risfdep(:,:) ) * zssht_h(:,:) + risfdep(:,:)
+            gde3w_n(:,:,jk) =   gdept_n(:,:,jk) - sshn(:,:)
+         END DO
+      ELSE                    ! no ISF cavities
+         DO jk = 1, jpkm1
+            gdept_n(:,:,jk) = gdept_0(:,:,jk) * zssht_h(:,:)
+            gdepw_n(:,:,jk) = gdepw_0(:,:,jk) * zssht_h(:,:)
+            gde3w_n(:,:,jk) = gdept_n(:,:,jk) - sshn(:,:)
+         END DO
+      ENDIF
+      !
+   END SUBROUTINE ssh2e3_now
+   
+   
+   SUBROUTINE ssh2e3_before
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE ssh2e3_before  ***
+      !!----------------------------------------------------------------------
+      INTEGER ::   ji, jj, jk
+      REAL(wp), DIMENSION(jpi,jpj) ::   zssht_h, zsshu_h, zsshv_h
+      !!----------------------------------------------------------------------
+      !
+      !                             !==  ssh at u- and v-points  ==!
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            zsshu_h(ji,jj) = 0.5_wp  * ( sshb(ji  ,jj) + sshb(ji+1,jj  ) ) * ssumask(ji,jj)
+            zsshv_h(ji,jj) = 0.5_wp  * ( sshb(ji  ,jj) + sshb(ji  ,jj+1) ) * ssvmask(ji,jj)
+         END DO
+      END DO      
+      CALL lbc_lnk_multi( zsshu_h(:,:),'U', 1._wp , zsshv_h(:,:),'V', 1._wp )
+      !
+      !                             !==  ht, hu and hv  == !   (and their inverse)
+         hu_b(:,:) = hu_0(:,:) + zsshu_h(:,:)
+         hv_b(:,:) = hv_0(:,:) + zsshv_h(:,:)
+      r1_hu_b(:,:) = ssumask(:,:) / ( hu_b(:,:) + 1._wp - ssumask(:,:) )
+      r1_hv_b(:,:) = ssvmask(:,:) / ( hv_b(:,:) + 1._wp - ssvmask(:,:) )
+      !
+      !      
+      !                             !==  ssh / h  factor at t-, u- ,v- & f-points  ==!
+      zssht_h(:,:) = sshb (:,:) * r1_ht_0(:,:)
+      zsshu_h   (:,:) = zsshu_h(:,:) * r1_hu_0(:,:)
+      zsshv_h   (:,:) = zsshv_h(:,:) * r1_hv_0(:,:)
+      !
+      !                             !==  e3t, e3w  ,  e3u, e3uw , and  e3v, e3vw  ==!
+      DO jk = 1, jpkm1
+          e3t_b(:,:,jk) =  e3t_0(:,:,jk) * ( 1._wp + zssht_h(:,:) * tmask(:,:,jk) )
+          e3w_b(:,:,jk) =  e3w_0(:,:,jk) * ( 1._wp + zssht_h(:,:) * tmask(:,:,jk) )
+          !
+          e3u_b(:,:,jk) =  e3u_0(:,:,jk) * ( 1._wp + zsshu_h  (:,:) *  umask(:,:,jk) )
+         e3uw_b(:,:,jk) = e3uw_0(:,:,jk) * ( 1._wp + zsshu_h  (:,:) * wumask(:,:,jk) )
+          !
+          e3v_b(:,:,jk) =  e3v_0(:,:,jk) * ( 1._wp + zsshv_h  (:,:) *  vmask(:,:,jk) )
+         e3vw_b(:,:,jk) = e3vw_0(:,:,jk) * ( 1._wp + zsshv_h  (:,:) * wvmask(:,:,jk) )
+      END DO
+      !   
+   END SUBROUTINE ssh2e3_before
+   
    !!======================================================================
 END MODULE domvvl
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/iscplrst.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/iscplrst.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/iscplrst.F90	(revision 10001)
@@ -14,5 +14,4 @@
    USE dom_oce         ! ocean space and time domain
    USE domwri          ! ocean space and time domain
-   USE domvvl   , ONLY : dom_vvl_interpol
    USE phycst          ! physical constants
    USE sbc_oce         ! surface boundary condition variables
@@ -137,7 +136,8 @@
       REAL(wp), DIMENSION(jpi,jpj)          :: zdmask , zsmask0, zucorr, zbub, zbun, zssh0, zhu1, zde3t
       REAL(wp), DIMENSION(jpi,jpj)          :: zdsmask, zsmask1, zvcorr, zbvb, zbvn, zssh1, zhv1
-      REAL(wp), DIMENSION(jpi,jpj,jpk)      :: ztmask0, zwmaskn, ztrp
+      REAL(wp), DIMENSION(jpi,jpj,jpk)      :: ztmask0, zwmaskn
       REAL(wp), DIMENSION(jpi,jpj,jpk)      :: ztmask1, zwmaskb, ztmp3d
       REAL(wp), DIMENSION(jpi,jpj,jpk,jpts) :: zts0
+      REAL(wp), DIMENSION(jpi,jpj) ::   z_ssh_h0, zsshu, zsshv, zsshf
       !!----------------------------------------------------------------------
       !
@@ -163,13 +163,11 @@
          DO jj = 2,jpj-1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               jip1=ji+1; jim1=ji-1;
-               jjp1=jj+1; jjm1=jj-1;
-               summsk=(zsmask0(jip1,jj)+zsmask0(jim1,jj)+zsmask0(ji,jjp1)+zsmask0(ji,jjm1))
+               summsk = zsmask0(ji+1,jj)+zsmask0(ji-1,jj)+zsmask0(ji,jj+1)+zsmask0(ji,jj-1)
                IF (zdsmask(ji,jj) == 1._wp .AND. summsk /= 0._wp) THEN
-                  sshn(ji,jj)=( zssh0(jip1,jj)*zsmask0(jip1,jj)     &
-                  &           + zssh0(jim1,jj)*zsmask0(jim1,jj)     &
-                  &           + zssh0(ji,jjp1)*zsmask0(ji,jjp1)     &
-                  &           + zssh0(ji,jjm1)*zsmask0(ji,jjm1))/summsk
-                  zsmask1(ji,jj)=1._wp
+                  sshn(ji,jj)=( zssh0(ji+1,jj)*zsmask0(ji+1,jj)     &
+                  &           + zssh0(ji-1,jj)*zsmask0(ji-1,jj)     &
+                  &           + zssh0(ji,jj+1)*zsmask0(ji,jj+1)     &
+                  &           + zssh0(ji,jj-1)*zsmask0(ji,jj+1)) / summsk
+                  zsmask1(ji,jj) = 1._wp
                ENDIF
             END DO
@@ -185,76 +183,95 @@
       IF ( .NOT.ln_linssh ) THEN
       ! Reconstruction of all vertical scale factors at now time steps
-      ! =============================================================================
+      ! ======================================================================
+      
+!!gm Question : bug ????
+      ! at this stage  is ht_0, r1_ht0 already computed ????
+      ! I have the feeling that this should be done in a different manner...
+      ! that is iscpl_rst_interpol  should be call directly in restart !!!
+      
+      ! in my changes here I assume that ht_0 AND  r1_ht_0  have been updated 
+      ! Note that the former calculation were using ht_0  so if it as not been updated ===>>> BUG
+!!gm
+      
+      
       ! Horizontal scale factor interpolations
       ! --------------------------------------
-         DO jk = 1,jpk
-            DO jj=1,jpj
-               DO ji=1,jpi
-                  IF (tmask(ji,jj,1) == 0._wp .OR. ptmask_b(ji,jj,1) == 0._wp) THEN
-                     e3t_n(ji,jj,jk) = e3t_0(ji,jj,jk) * ( 1._wp + sshn(ji,jj) /   &
-                     &   ( ht_0(ji,jj) + 1._wp - ssmask(ji,jj) ) * tmask(ji,jj,jk) )
-                  ENDIF
-               END DO
-            END DO
-         END DO
-         !
-         CALL dom_vvl_interpol( e3t_n(:,:,:), e3u_n(:,:,:), 'U' )
-         CALL dom_vvl_interpol( e3t_n(:,:,:), e3v_n(:,:,:), 'V' )
-         CALL dom_vvl_interpol( e3u_n(:,:,:), e3f_n(:,:,:), 'F' )
-
-         ! Vertical scale factor interpolations
-         ! ------------------------------------
-         CALL dom_vvl_interpol( e3t_n(:,:,:), e3w_n (:,:,:), 'W'  )
-         CALL dom_vvl_interpol( e3u_n(:,:,:), e3uw_n(:,:,:), 'UW' )
-         CALL dom_vvl_interpol( e3v_n(:,:,:), e3vw_n(:,:,:), 'VW' )
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               IF ( tmask(ji,jj,1) == 0._wp .OR. ptmask_b(ji,jj,1) == 0._wp ) THEN
+                  DO jk = 1, jpk
+                     e3t_n(ji,jj,jk) = e3t_0(ji,jj,jk) * ( 1._wp + sshn(ji,jj) * r1_ht_0(ji,jj) * tmask(ji,jj,jk) )
+                  END DO
+               ENDIF
+            END DO
+         END DO
+         !
+!!gm  Note that if this routine is called in dom_vvl_init then all the lines below are uselss !!!
+!!        they are a duplication of dom_vvl_init lines
+
+         !                                   !==  now fields  ==!
+         !
+         !                                            !* ssh at u- and v-points)
+         DO jj = 1, jpjm1   ;   DO ji = 1, jpim1            ! start from 1 due to f-point
+            zsshu(ji,jj) = 0.5_wp  * ( sshn(ji  ,jj) + sshn(ji+1,jj  ) ) * ssumask(ji,jj)
+            zsshv(ji,jj) = 0.5_wp  * ( sshn(ji  ,jj) + sshn(ji  ,jj+1) ) * ssvmask(ji,jj)
+            zsshf(ji,jj) = 0.25_wp * ( sshn(ji  ,jj) + sshn(ji  ,jj+1)   & 
+               &                     + sshn(ji+1,jj) + sshn(ji+1,jj+1) ) * ssfmask(ji,jj)
+         END DO             ;   END DO      
+         CALL lbc_lnk_multi( zsshu(:,:),'U', 1._wp , zsshu(:,:),'V', 1._wp , zsshf(:,:),'F', 1._wp )
+         !
+         !                                            !* hu and hv (and their inverse) 
+         ht_n   (:,:) = ht_0(:,:) +  sshn(:,:)
+         hu_n   (:,:) = hu_0(:,:) + zsshu(:,:)
+         hv_n   (:,:) = hv_0(:,:) + zsshv(:,:)
+         r1_hu_n(:,:) = ssumask(:,:) / ( hu_n(:,:) + 1._wp - ssumask(:,:) )    ! ss mask mask due to ISF
+         r1_hv_n(:,:) = ssvmask(:,:) / ( hv_n(:,:) + 1._wp - ssvmask(:,:) )
+         !
+         !                                            !* e3u, e3uw  and  e3v, e3vw
+         z_ssh_h0(:,:) = sshn (:,:) * r1_ht_0(:,:)           ! t-point
+         DO jk = 1, jpkm1
+            e3w_n(:,:,jk) = e3w_0(:,:,jk) * ( 1._wp + z_ssh_h0(:,:) * tmask(:,:,jk) )
+         END DO
+         z_ssh_h0(:,:) = zsshu(:,:) * r1_hu_0(:,:)           ! u-point
+         DO jk = 1, jpkm1
+            e3u_n (:,:,jk) = e3u_0 (:,:,jk) * ( 1._wp + z_ssh_h0(:,:) *  umask(:,:,jk) )
+            e3uw_n(:,:,jk) = e3uw_0(:,:,jk) * ( 1._wp + z_ssh_h0(:,:) * wumask(:,:,jk) )
+         END DO
+         z_ssh_h0(:,:) = zsshv(:,:) * r1_hv_0(:,:)           ! v-point
+         DO jk = 1, jpkm1
+            e3v_n (:,:,jk) = e3v_0 (:,:,jk) * ( 1._wp + z_ssh_h0(:,:) *  vmask(:,:,jk) )
+            e3vw_n(:,:,jk) = e3vw_0(:,:,jk) * ( 1._wp + z_ssh_h0(:,:) * wvmask(:,:,jk) )
+         END DO
+         z_ssh_h0(:,:) = zsshf(:,:) * r1_hf_0(:,:)           ! f-point
+         DO jk = 1, jpkm1
+            e3f_n(:,:,jk) = e3f_0(:,:,jk) * ( 1._wp + z_ssh_h0(:,:) * fmask(:,:,jk) )
+         END DO
+
+         z_ssh_h0(:,:) = 1._wp + sshn(:,:) * r1_ht_0(:,:)    ! t-point
+         !
+         IF( ln_isfcav ) THEN    ! iceshelf cavities : ssh scaling not applied over the iceshelf thickness 
+            DO jk = 1, jpkm1
+               gdept_n(:,:,jk) = ( gdept_0(:,:,jk) - risfdep(:,:) ) * z_ssh_h0(:,:) + risfdep(:,:)
+               gdepw_n(:,:,jk) = ( gdepw_0(:,:,jk) - risfdep(:,:) ) * z_ssh_h0(:,:) + risfdep(:,:)
+               gde3w_n(:,:,jk) = gdept_n(:,:,jk) - sshn(:,:)
+            END DO
+         ELSE
+            DO jk = 1, jpkm1
+               gdept_n(:,:,jk) = gdept_0(:,:,jk) * z_ssh_h0(:,:)
+               gdepw_n(:,:,jk) = gdepw_0(:,:,jk) * z_ssh_h0(:,:)
+               gde3w_n(:,:,jk) = gdept_n(:,:,jk) - sshn(:,:)
+            END DO
+         ENDIF
          
-         ! t- and w- points depth
-         ! ----------------------
-         gdept_n(:,:,1) = 0.5_wp * e3w_n(:,:,1)
-         gdepw_n(:,:,1) = 0.0_wp
-         gde3w_n(:,:,1) = gdept_n(:,:,1) - sshn(:,:)
-         DO jj = 1,jpj
-            DO ji = 1,jpi
-               DO jk = 2,mikt(ji,jj)-1
-                  gdept_n(ji,jj,jk) = gdept_0(ji,jj,jk)
-                  gdepw_n(ji,jj,jk) = gdepw_0(ji,jj,jk)
-                  gde3w_n(ji,jj,jk) = gdept_0(ji,jj,jk) - sshn(ji,jj)
-               END DO
-               IF (mikt(ji,jj) > 1) THEN
-                  jk = mikt(ji,jj)
-                  gdept_n(ji,jj,jk) = gdepw_0(ji,jj,jk) + 0.5_wp * e3w_n(ji,jj,jk)
-                  gdepw_n(ji,jj,jk) = gdepw_0(ji,jj,jk)
-                  gde3w_n(ji,jj,jk) = gdept_n(ji,jj,jk  ) - sshn   (ji,jj)
-               END IF
-               DO jk = mikt(ji,jj)+1, jpk
-                  gdept_n(ji,jj,jk) = gdept_n(ji,jj,jk-1) + e3w_n(ji,jj,jk)
-                  gdepw_n(ji,jj,jk) = gdepw_n(ji,jj,jk-1) + e3t_n(ji,jj,jk-1)
-                  gde3w_n(ji,jj,jk) = gdept_n(ji,jj,jk  ) - sshn (ji,jj)
-               END DO
-            END DO
-         END DO
-
-      ! t-, u- and v- water column thickness
-      ! ------------------------------------
-         ht_n(:,:) = 0._wp ; hu_n(:,:) = 0._wp ; hv_n(:,:) = 0._wp
-         DO jk = 1, jpkm1
-            hu_n(:,:) = hu_n(:,:) + e3u_n(:,:,jk) * umask(:,:,jk)
-            hv_n(:,:) = hv_n(:,:) + e3v_n(:,:,jk) * vmask(:,:,jk)
-            ht_n(:,:) = ht_n(:,:) + e3t_n(:,:,jk) * tmask(:,:,jk)
-         END DO
-         !                                        ! Inverse of the local depth
-         r1_hu_n(:,:) = 1._wp / ( hu_n(:,:) + 1._wp - ssumask(:,:) ) * ssumask(:,:)
-         r1_hv_n(:,:) = 1._wp / ( hv_n(:,:) + 1._wp - ssvmask(:,:) ) * ssvmask(:,:)
-
-      END IF
+      ENDIF
 
 !=============================================================================
 ! compute velocity
 ! compute velocity in order to conserve barotropic velocity (modification by poderation of the scale factor).
-      ub(:,:,:)=un(:,:,:)
-      vb(:,:,:)=vn(:,:,:)
-      DO jk = 1,jpk
-         DO jj = 1,jpj
-            DO ji = 1,jpi
+      ub(:,:,:) = un(:,:,:)
+      vb(:,:,:) = vn(:,:,:)
+      DO jk = 1, jpk
+         DO jj = 1, jpj
+            DO ji = 1, jpi
                un(ji,jj,jk) = ub(ji,jj,jk)*pe3u_b(ji,jj,jk)*pumask_b(ji,jj,jk)/e3u_n(ji,jj,jk)*umask(ji,jj,jk);
                vn(ji,jj,jk) = vb(ji,jj,jk)*pe3v_b(ji,jj,jk)*pvmask_b(ji,jj,jk)/e3v_n(ji,jj,jk)*vmask(ji,jj,jk);
@@ -265,12 +282,8 @@
 ! compute new velocity if we close a cell (check barotropic velocity and change velocity over the water column)
 ! compute barotropic velocity now and after 
-      ztrp(:,:,:) = ub(:,:,:)*pe3u_b(:,:,:); 
-      zbub(:,:)   = SUM(ztrp,DIM=3)
-      ztrp(:,:,:) = vb(:,:,:)*pe3v_b(:,:,:); 
-      zbvb(:,:)   = SUM(ztrp,DIM=3)
-      ztrp(:,:,:) = un(:,:,:)*e3u_n(:,:,:); 
-      zbun(:,:)   = SUM(ztrp,DIM=3)
-      ztrp(:,:,:) = vn(:,:,:)*e3v_n(:,:,:); 
-      zbvn(:,:)   = SUM(ztrp,DIM=3)
+      zbub(:,:)   = SUM( ub(:,:,:)*pe3u_b(:,:,:) , DIM=3 )
+      zbvb(:,:)   = SUM( vb(:,:,:)*pe3v_b(:,:,:) , DIM=3 )
+      zbun(:,:)   = SUM( un(:,:,:)* e3u_n(:,:,:) , DIM=3 )
+      zbvn(:,:)   = SUM( vn(:,:,:)* e3v_n(:,:,:) , DIM=3 )
 
       ! new water column
@@ -285,6 +298,6 @@
       zucorr = 0._wp
       zvcorr = 0._wp
-      DO jj = 1,jpj
-         DO ji = 1,jpi
+      DO jj = 1, jpj
+         DO ji = 1, jpi
             IF (zbun(ji,jj) /= zbub(ji,jj) .AND. zhu1(ji,jj) /= 0._wp ) THEN
                zucorr(ji,jj) = (zbun(ji,jj) - zbub(ji,jj))/zhu1(ji,jj)
@@ -297,7 +310,7 @@
       
       ! update velocity
-      DO jk  = 1,jpk
-         un(:,:,jk)=(un(:,:,jk) - zucorr(:,:))*umask(:,:,jk)
-         vn(:,:,jk)=(vn(:,:,jk) - zvcorr(:,:))*vmask(:,:,jk)
+      DO jk  = 1, jpk
+         un(:,:,jk) = ( un(:,:,jk) - zucorr(:,:) ) * umask(:,:,jk)
+         vn(:,:,jk) = ( vn(:,:,jk) - zvcorr(:,:) ) * vmask(:,:,jk)
       END DO
 
@@ -305,49 +318,49 @@
       ! compute temp and salt
       ! compute new tn and sn if we open a new cell
-      tsb (:,:,:,:) = tsn(:,:,:,:)
-      zts0(:,:,:,:) = tsn(:,:,:,:)
+      tsb  (:,:,:,:) = tsn   (:,:,:,:)
+      zts0 (:,:,:,:) = tsn   (:,:,:,:)
       ztmask1(:,:,:) = ptmask_b(:,:,:)
       ztmask0(:,:,:) = ptmask_b(:,:,:)
       DO iz = 1,nn_drown ! resolution dependent (OK for ISOMIP+ case)
-          DO jk = 1,jpk-1
-              zdmask=tmask(:,:,jk)-ztmask0(:,:,jk);
-              DO jj = 2,jpj-1
-                 DO ji = fs_2,fs_jpim1
-                      jip1=ji+1; jim1=ji-1;
-                      jjp1=jj+1; jjm1=jj-1;
-                      summsk= (ztmask0(jip1,jj  ,jk)+ztmask0(jim1,jj  ,jk)+ztmask0(ji  ,jjp1,jk)+ztmask0(ji  ,jjm1,jk))
-                      IF (zdmask(ji,jj) == 1._wp .AND. summsk /= 0._wp) THEN
-                      !! horizontal basic extrapolation
-                         tsn(ji,jj,jk,1)=( zts0(jip1,jj  ,jk,1)*ztmask0(jip1,jj  ,jk) &
-                         &                +zts0(jim1,jj  ,jk,1)*ztmask0(jim1,jj  ,jk) &
-                         &                +zts0(ji  ,jjp1,jk,1)*ztmask0(ji  ,jjp1,jk) &
-                         &                +zts0(ji  ,jjm1,jk,1)*ztmask0(ji  ,jjm1,jk) ) / summsk
-                         tsn(ji,jj,jk,2)=( zts0(jip1,jj  ,jk,2)*ztmask0(jip1,jj  ,jk) &
-                         &                +zts0(jim1,jj  ,jk,2)*ztmask0(jim1,jj  ,jk) &
-                         &                +zts0(ji  ,jjp1,jk,2)*ztmask0(ji  ,jjp1,jk) &
-                         &                +zts0(ji  ,jjm1,jk,2)*ztmask0(ji  ,jjm1,jk) ) / summsk
-                         ztmask1(ji,jj,jk)=1
-                      ELSEIF (zdmask(ji,jj) == 1._wp .AND. summsk == 0._wp) THEN
-                      !! vertical extrapolation if horizontal extrapolation failed
-                         jkm1=max(1,jk-1) ; jkp1=min(jpk,jk+1)
-                         summsk=(ztmask0(ji,jj,jkm1)+ztmask0(ji,jj,jkp1))
-                         IF (zdmask(ji,jj) == 1._wp .AND. summsk /= 0._wp ) THEN
-                            tsn(ji,jj,jk,1)=( zts0(ji,jj,jkp1,1)*ztmask0(ji,jj,jkp1)     &
-                            &                +zts0(ji,jj,jkm1,1)*ztmask0(ji,jj,jkm1))/summsk
-                            tsn(ji,jj,jk,2)=( zts0(ji,jj,jkp1,2)*ztmask0(ji,jj,jkp1)     &
-                            &                +zts0(ji,jj,jkm1,2)*ztmask0(ji,jj,jkm1))/summsk
-                            ztmask1(ji,jj,jk)=1._wp
-                         END IF
-                      END IF
-                  END DO
-              END DO
-          END DO
-          
-          CALL lbc_lnk_multi( tsn(:,:,:,jp_tem), 'T', 1., tsn(:,:,:,jp_sal), 'T', 1., ztmask1, 'T', 1.)
-
-          ! update
-          zts0(:,:,:,:) = tsn(:,:,:,:)
-          ztmask0 = ztmask1
-
+         DO jk = 1,jpk-1
+            zdmask=tmask(:,:,jk)-ztmask0(:,:,jk);
+            DO jj = 2,jpj-1
+               DO ji = fs_2,fs_jpim1
+                  jip1=ji+1; jim1=ji-1;
+                  jjp1=jj+1; jjm1=jj-1;
+                  summsk= (ztmask0(jip1,jj  ,jk)+ztmask0(jim1,jj  ,jk)+ztmask0(ji  ,jjp1,jk)+ztmask0(ji  ,jjm1,jk))
+                  IF (zdmask(ji,jj) == 1._wp .AND. summsk /= 0._wp) THEN
+                     !! horizontal basic extrapolation
+                     tsn(ji,jj,jk,1)=( zts0(jip1,jj  ,jk,1)*ztmask0(jip1,jj  ,jk) &
+                         &            +zts0(jim1,jj  ,jk,1)*ztmask0(jim1,jj  ,jk) &
+                         &            +zts0(ji  ,jjp1,jk,1)*ztmask0(ji  ,jjp1,jk) &
+                         &            +zts0(ji  ,jjm1,jk,1)*ztmask0(ji  ,jjm1,jk) ) / summsk
+                     tsn(ji,jj,jk,2)=( zts0(jip1,jj  ,jk,2)*ztmask0(jip1,jj  ,jk) &
+                         &            +zts0(jim1,jj  ,jk,2)*ztmask0(jim1,jj  ,jk) &
+                         &            +zts0(ji  ,jjp1,jk,2)*ztmask0(ji  ,jjp1,jk) &
+                         &            +zts0(ji  ,jjm1,jk,2)*ztmask0(ji  ,jjm1,jk) ) / summsk
+                     ztmask1(ji,jj,jk)=1
+                  ELSEIF (zdmask(ji,jj) == 1._wp .AND. summsk == 0._wp) THEN
+                     !! vertical extrapolation if horizontal extrapolation failed
+                     jkm1=max(1,jk-1) ; jkp1=min(jpk,jk+1)
+                     summsk=(ztmask0(ji,jj,jkm1)+ztmask0(ji,jj,jkp1))
+                     IF (zdmask(ji,jj) == 1._wp .AND. summsk /= 0._wp ) THEN
+                        tsn(ji,jj,jk,1)=( zts0(ji,jj,jkp1,1)*ztmask0(ji,jj,jkp1)     &
+                            &            +zts0(ji,jj,jkm1,1)*ztmask0(ji,jj,jkm1)) / summsk
+                        tsn(ji,jj,jk,2)=( zts0(ji,jj,jkp1,2)*ztmask0(ji,jj,jkp1)     &
+                            &            +zts0(ji,jj,jkm1,2)*ztmask0(ji,jj,jkm1)) / summsk
+                        ztmask1(ji,jj,jk)=1._wp
+                     ENDIF
+                  ENDIF
+               END DO
+            END DO
+         END DO
+         !
+         CALL lbc_lnk_multi( tsn(:,:,:,jp_tem), 'T', 1., tsn(:,:,:,jp_sal), 'T', 1., ztmask1, 'T', 1.)
+         !
+         ! update
+         zts0(:,:,:,:) = tsn(:,:,:,:)
+         ztmask0 = ztmask1
+         !
       END DO
 
@@ -395,6 +408,6 @@
       ! set mbkt and mikt to 1 in thiese location
       WHERE (SUM(tmask,dim=3) == 0)
-         mbkt(:,:)=1 ; mbku(:,:)=1 ; mbkv(:,:)=1
-         mikt(:,:)=1 ; miku(:,:)=1 ; mikv(:,:)=1
+         mbkt(:,:) = 1   ;   mbku(:,:)=1   ;   mbkv(:,:) = 1
+         mikt(:,:) = 1   ;   miku(:,:)=1   ;   mikv(:,:) = 1
       END WHERE
       ! -------------------------------------------------------------------------------------------
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DYN/dynadv.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DYN/dynadv.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DYN/dynadv.F90	(revision 10001)
@@ -121,4 +121,8 @@
       ENDIF
 
+!!gm 
+      IF ( ln_dynadv_vec )   CALL ctl_stop( 'Vector form not available in this branch' )
+!!gm
+
       ioptio = 0                      ! parameter control and set n_dynadv
       IF( ln_dynadv_OFF  ) THEN   ;   ioptio = ioptio + 1   ;   n_dynadv = np_LIN_dyn   ;   ENDIF
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DYN/dynnxt.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DYN/dynnxt.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DYN/dynnxt.F90	(revision 10001)
@@ -20,4 +20,6 @@
    !!            3.6  !  2014-04  (G. Madec) add the diagnostic of the time filter trends
    !!            3.7  !  2015-11  (J. Chanut) Free surface simplification
+   !!            4.0  !  2018-07  (G. Madec)   1- z-star (s-star) only  
+   !!                                          2- remove   dom_vvl_interpol  
    !!-------------------------------------------------------------------------
   
@@ -34,5 +36,5 @@
    USE dynspg_ts      ! surface pressure gradient: split-explicit scheme
    USE domvvl         ! variable volume
-   USE bdy_oce   , ONLY: ln_bdy
+   USE bdy_oce , ONLY : ln_bdy
    USE bdydta         ! ocean open boundary conditions
    USE bdydyn         ! ocean open boundary conditions
@@ -92,5 +94,5 @@
       !!               un,vn   now horizontal velocity of next time-step
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
@@ -100,4 +102,5 @@
       REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   zue, zve
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   ze3u_f, ze3v_f, zua, zva 
+      REAL(wp), DIMENSION(jpi,jpj) ::   z_ssh_h0, zsshu, zsshv
       !!----------------------------------------------------------------------
       !
@@ -212,7 +215,7 @@
             !    => time filter + conservation correction (only at the first level)
             zcoef = rn_atfp * rn_Dt * r1_rho0
-
+            !
             e3t_b(:,:,1) = e3t_b(:,:,1) - zcoef * ( emp_b(:,:) - emp(:,:) ) * tmask(:,:,1)
-
+            !
             IF ( ln_rnf ) THEN
                IF( ln_rnf_depth ) THEN
@@ -228,8 +231,8 @@
                   END DO
                ELSE
-                  e3t_b(:,:,1) = e3t_b(:,:,1) - zcoef *  ( -rnf_b(:,:) + rnf(:,:))*tmask(:,:,1)
+                  e3t_b(:,:,1) = e3t_b(:,:,1) - zcoef *  ( -rnf_b(:,:) + rnf(:,:) )*tmask(:,:,1)
                ENDIF
             ENDIF
-
+            !
             IF ( ln_isf ) THEN   ! if ice shelf melting
                DO jk = 1, jpkm1 ! Deal with isf separetely, as can be through depth too
@@ -245,8 +248,24 @@
             ENDIF
             !
+            !
             IF( ln_dynadv_vec ) THEN      ! Asselin filter applied on velocity
-               ! Before filtered scale factor at (u/v)-points
-               CALL dom_vvl_interpol( e3t_b(:,:,:), e3u_b(:,:,:), 'U' )
-               CALL dom_vvl_interpol( e3t_b(:,:,:), e3v_b(:,:,:), 'V' )
+               !                                            !* ssh at u- and v-points)
+               DO jj = 2, jpjm1   ;   DO ji = 2, jpim1
+                  zsshu(ji,jj) = 0.5_wp  * ( sshb(ji  ,jj) + sshb(ji+1,jj  ) ) * ssumask(ji,jj)
+                  zsshv(ji,jj) = 0.5_wp  * ( sshb(ji  ,jj) + sshb(ji  ,jj+1) ) * ssvmask(ji,jj)
+               END DO             ;   END DO      
+               CALL lbc_lnk_multi( zsshu(:,:),'U', 1._wp , zsshu(:,:),'V', 1._wp )
+               !
+               !
+               !                                            !* e3u and e3v 
+               z_ssh_h0(:,:) = zsshu(:,:) * r1_hu_0(:,:)           ! u-point
+               DO jk = 1, jpkm1
+                  e3u_b (:,:,jk) = e3u_0 (:,:,jk) * ( 1._wp + z_ssh_h0(:,:) * umask(:,:,jk) )
+               END DO
+               z_ssh_h0(:,:) = zsshv(:,:) * r1_hv_0(:,:)           ! v-point
+               DO jk = 1, jpkm1
+                  e3v_b (:,:,jk) = e3v_0 (:,:,jk) * ( 1._wp + z_ssh_h0(:,:) * vmask(:,:,jk) )
+               END DO
+               !
                DO jk = 1, jpkm1
                   DO jj = 1, jpj
@@ -266,7 +285,23 @@
                !
                ALLOCATE( ze3u_f(jpi,jpj,jpk) , ze3v_f(jpi,jpj,jpk) )
-               ! Before filtered scale factor at (u/v)-points stored in ze3u_f, ze3v_f
-               CALL dom_vvl_interpol( e3t_b(:,:,:), ze3u_f, 'U' )
-               CALL dom_vvl_interpol( e3t_b(:,:,:), ze3v_f, 'V' )
+               !
+               !                                            !* ssh at u- and v-points)
+               DO jj = 2, jpjm1   ;   DO ji = 2, jpim1
+                  zsshu(ji,jj) = 0.5_wp  * ( sshb(ji  ,jj) + sshb(ji+1,jj  ) ) * ssumask(ji,jj)
+                  zsshv(ji,jj) = 0.5_wp  * ( sshb(ji  ,jj) + sshb(ji  ,jj+1) ) * ssvmask(ji,jj)
+               END DO             ;   END DO      
+               CALL lbc_lnk_multi( zsshu(:,:),'U', 1._wp , zsshu(:,:),'V', 1._wp )
+               !
+               !
+               !                                            !* e3u and e3v 
+               z_ssh_h0(:,:) = zsshu(:,:) * r1_hu_0(:,:)           ! u-point
+               DO jk = 1, jpkm1
+                  ze3u_f(:,:,jk) = e3u_0 (:,:,jk) * ( 1._wp + z_ssh_h0(:,:) * umask(:,:,jk) )
+               END DO
+               z_ssh_h0(:,:) = zsshv(:,:) * r1_hv_0(:,:)           ! v-point
+               DO jk = 1, jpkm1
+                  ze3u_f(:,:,jk) = e3v_0 (:,:,jk) * ( 1._wp + z_ssh_h0(:,:) * vmask(:,:,jk) )
+               END DO
+               !
                DO jk = 1, jpkm1
                   DO jj = 1, jpj
@@ -319,14 +354,17 @@
       !
       IF(.NOT.ln_linssh ) THEN
-         hu_b(:,:) = e3u_b(:,:,1) * umask(:,:,1)
-         hv_b(:,:) = e3v_b(:,:,1) * vmask(:,:,1)
-         DO jk = 2, jpkm1
-            hu_b(:,:) = hu_b(:,:) + e3u_b(:,:,jk) * umask(:,:,jk)
-            hv_b(:,:) = hv_b(:,:) + e3v_b(:,:,jk) * vmask(:,:,jk)
-         END DO
-         r1_hu_b(:,:) = ssumask(:,:) / ( hu_b(:,:) + 1._wp - ssumask(:,:) )
+         DO jj = 2, jpjm1   ;   DO ji = 2, jpim1
+            zsshu(ji,jj) = 0.5_wp  * ( sshb(ji  ,jj) + sshb(ji+1,jj  ) ) * ssumask(ji,jj)
+            zsshv(ji,jj) = 0.5_wp  * ( sshb(ji  ,jj) + sshb(ji  ,jj+1) ) * ssvmask(ji,jj)
+         END DO             ;   END DO      
+         CALL lbc_lnk_multi( zsshu(:,:),'U', 1._wp , zsshu(:,:),'V', 1._wp )
+         !
+         hu_b   (:,:) = hu_0(:,:) + zsshu(:,:)
+         hv_b   (:,:) = hv_0(:,:) + zsshv(:,:)
+         r1_hu_b(:,:) = ssumask(:,:) / ( hu_b(:,:) + 1._wp - ssumask(:,:) )    ! _i mask due to ISF
          r1_hv_b(:,:) = ssvmask(:,:) / ( hv_b(:,:) + 1._wp - ssvmask(:,:) )
       ENDIF
       !
+      !                                   ! 
       un_b(:,:) = e3u_a(:,:,1) * un(:,:,1) * umask(:,:,1)
       ub_b(:,:) = e3u_b(:,:,1) * ub(:,:,1) * umask(:,:,1)
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DYN/dynzdf.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DYN/dynzdf.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DYN/dynzdf.F90	(revision 10001)
@@ -458,5 +458,5 @@
          !                                ! Note also that now e3 scale factors are used as after one are not computed !
          !
-         CALL wrk_alloc(jpi,jpj,   z2d )
+         ALLOCATE( z2d(jpi,jpj) )
          z2d(:,:) = 0._wp
          DO jk = 1, jpkm1
@@ -498,4 +498,5 @@
          CALL lbc_lnk( z2d,'T', 1. )
          CALL iom_put( 'dispkevfo', z2d )
+         DEALLOCATE( z2d )
       ENDIF
       !
